/*
 	[Un]zipper, a simple and yet useful Browser add-on. (version 1.11)
	And it is multithreaded ! :-)

 	Copyright 1997 by Olivier Wittenberg (witt@lenet.fr).

 	To use it, put it in your /boot/system/add-ons/Browser/ directory.
*/

#pragma export on
void process_refs (record_ref, BMessage *, void *);
#pragma export off

void Zwait_for_the_end ();

long tcount;
thread_id *thids;

void Zwait_for_the_end ()
{
	long i, retval;
	
	for (i = 0; i < tcount; i++)
		wait_for_thread (thids[i], &retval);
	// I prefer not to use retval because the thread may be already gone: in this case
	// wait_for_thread doesn't return B_NO_ERROR and I guess 'retval' is invalid...
	// Anyway, if there is an error, the file won't be zip'ed/unzip'ed...
}

void process_refs (record_ref dir, BMessage *msg, void *)
{
	double time = system_time ();
	long count;
	
	{ // How many icons were selected ?
		ulong type;
		
		msg->GetInfo ("refs", &type, &count);
	}
	
	if (!count) {
		(new BAlert (NULL, "You must have a selection to run [Un]zipper.", "OK"))->Go ();
		return;
	}
	thids = (thread_id *) malloc (sizeof (thread_id) * count);

	{ // A new block will save stack memory (notice 'char path[1024]')
		BDirectory cdir;
	
		cdir.SetRef (dir);
		if (cdir.Error () != B_NO_ERROR) {
			(new BAlert (NULL, "You must call [Un]zipper from folders.", "OK"))->Go ();
			return;
		}
		char path[1024];
		
		cdir.GetPath (path, 1024);
		chdir (path);
	}

	char name[B_FILE_NAME_LENGTH], **gargv = (char **) malloc (sizeof (char *) * 4);
	thread_id thid;
	long i;
	record_ref rref;
	BFile file;

	for (i = 0; i < count; i++) {
		rref = msg->FindRef ("refs", i);
		if (!does_ref_conform (rref, "File")) {
			static bool only_file_said;
			
			if (!only_file_said) {
				(new BAlert (NULL, "Only a file can be gzip'ed or gunzip'ed !", "Oops"))->Go ();
				only_file_said = TRUE;
				time = system_time (); // Why ? Hmm, try gzip'ing a folder without this line...
			}
			continue; // Let's process the next one...
		}
		file.SetRef (rref);
		file.GetName (name);
		gargv[1] = name;		
		gargv[2] = NULL;
		{
			char *p = NULL, *p2 = name;
			
			while (p2 = strchr (p2, '.')) p = p2++;
			
			if (p)
				if (p[1] == 'g' && p[2] == 'z' && !p[3] ||
					p[1] == 't' && p[2] == 'g' && p[3] == 'z' && !p[4])
					gargv[0] = "/boot/bin/gunzip";
				else
				if (p[1] == 'Z' && !p[2]) {
					gargv[0] = "/boot/bin/compress";
					gargv[2] = "-d";
					gargv[3] = NULL;
				}
				else
					gargv[0] = "/boot/bin/gzip";
			else
				gargv[0] = "/boot/bin/gzip";
		}
		extern char **environ;
		
		thids[tcount] = load_posix (gargv[0], gargv, environ);
		if (thids[tcount] > 0) {
			tcount++;			
			resume_thread (thids[tcount]);
		}
		else {
			(new BAlert (NULL, "Unable to launch gzip or gunzip.", "OK"))->Go ();
			Zwait_for_the_end ();
			return;
		}
	}
	Zwait_for_the_end ();
	
	if (system_time () - time > 1000000)
		(new BAlert (NULL, "[Un]zipper: operation finished.", "OK"))->Go ();
}